Description

Rails 5 now prefers to call #freeze on any string passed in as an attribute during validation, but this means attributes must not be

edited in-place with gsub! and similar methods. Some of the pre-validation methods used to normalise hostnames, OS names etc will

attempt to modify attributes in-place with gsub!, e.g.

HostsControllerTest::Fog.mock!#test_0001_#process_hostgroup changes compute attributes:

RuntimeError: can't modify frozen String

    app/models/nic/interface.rb:101:in `gsub!'

    app/models/nic/interface.rb:101:in `normalize_name'

    app/models/concerns/orchestration.rb:77:in `valid?'

    app/models/concerns/orchestration.rb:77:in `valid?'

    app/models/concerns/foreman/sti.rb:29:in `save_with_type'

    app/models/host.rb:15:in `method_missing'

    test/functional/hosts_controller_test.rb:1271:in `initialize_host'

 Prefer instead to retrieve and set the attribute through the regular attribute setter API (resource.foo = resource.foo.gsub(..)).

https://github.com/rails/rails/issues/24185 and related tickets have more info.

Associated revisions

Revision 976bf6e0 - 12/21/2016 10:42 AM - Dominic Cleal

fixes #16792 - don't modify AR record attributes in-place

Rails 5 may call #freeze on strings passed in as an attribute during

validation, so attributes must not be edited in-place with gsub! and

similar methods.

History

#1 - 10/04/2016 10:28 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3915 added

#2 - 12/21/2016 11:02 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 976bf6e0bdffa4a69fc76ee312060f815a6b7868.

#3 - 12/22/2016 03:58 AM - Dominic Cleal

- translation missing: en.field_release set to 209

Powered by TCPDF (www.tcpdf.org)

05/18/2024 1/1

https://github.com/rails/rails/issues/24185
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/976bf6e0bdffa4a69fc76ee312060f815a6b7868
http://www.tcpdf.org

